// encode utf-8
//
// 刮目せよ彼の死に様を。v0.0.1 (Watch His Way To Die v0.0.1)
//
// dgp.cpp
//
// "Watch His Way To Die" is a DGP-to-PNG decoder for "materia" system.
// And this code is based on DGPDecodingStream.java,v 1.1 in "NiseRingo"
// created by phonohawk and licenced GNU/GPL.
//
// Copyright (C) 2001,2003 phonohawk OHITO Yuki
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.


#include <windows.h>
#include <io.h>
#include <iostream>
#include <fstream>
#include <algorithm>
#include <functional>
#include <iterator>
#include <string>
#include <vector>
#include <boost/ref.hpp>
#include <boost/bind.hpp>
#include <boost/regex.hpp>
#include "dgp_dec.h"

typedef std::vector<std::string> vec_flist;

bool getfiles(const std::string &dirpath,vec_flist &list,vec_flist &nlist)
{
  WIN32_FIND_DATA FindFileData;
  HANDLE hfile = FindFirstFile((dirpath+"*.dgp").c_str(), &FindFileData);
  if (hfile==INVALID_HANDLE_VALUE)
    return false;
  else{
    list.push_back(dirpath+FindFileData.cFileName);
    nlist.push_back(FindFileData.cFileName);
  }
  while (FindNextFile(hfile, &FindFileData) != 0){
    list.push_back(dirpath+FindFileData.cFileName);
    nlist.push_back(FindFileData.cFileName);
  }
  FindClose(hfile);
  return true;
}

std::string dgp_to_png(const std::string &path,const std::string &name)
{
  dgp_dec(name.c_str(),path.c_str(),(path.substr(0,path.length()-3)+"png").c_str());
  return path.substr(0,path.length()-3)+"png";
}

int main(int argc,char **argv)
{
  boost::cmatch what;
  if(regex_match(GetCommandLine(), what, boost::regex("[^ ]+ +(-d|-r) +\"([^\"]*)\"")))
  {
    if(what.str(1)=="-d"){
      vec_flist dgp_list,dgp_nlist;
      if(!getfiles(what.str(2),dgp_list,dgp_nlist)){
        std::cout<<"harakiri! cannot find dgp file \""<<what.str(2)<<"\""<<std::endl;
        return -1;
      }
      std::ofstream of((what.str(2)+"$$remove.list").c_str());
      std::transform(
        dgp_list.begin(),
        dgp_list.end(),
        dgp_nlist.begin(),
        std::ostream_iterator<std::string>(of,"\n"),
        std::ptr_fun(dgp_to_png));
    }else if(what.str(1)=="-r"){
      std::ifstream _if((what.str(2)+"$$remove.list").c_str());
      if(!_if){
        std::cout<<"harakiri! incorrect path \""<<what.str(2)<<"\""<<std::endl;
        return -1;
      }

      while(!_if.eof()){
        std::string s;
        getline(_if,s,'\n');
        DeleteFile(s.c_str());
      }
      _if.close();
      DeleteFile((what.str(2)+"$$remove.list").c_str());
    }
    std::cout<<"OK BOSS!"<<std::endl;
  }else{
    std::cout<<"harakiri! dgp -d|r \"[path]\""<<std::endl;
    return -1;
  }
  return 0;
}
