/*
* encode utf-8
*
* ڂނ̎ɗlBv0.0.1 (Watch His Way To Die v0.0.1)
* 
* dgp_dec.c
* 
* "Watch His Way To Die" is a DGP-to-PNG decoder for "materia" system.
* And this code is based on DGPDecodingStream.java,v 1.1 in "NiseRingo"
* created by phonohawk and licenced GNU/GPL.
* 
* Copyright (C) 2001-2003 phonohawk OHITO Yuki
* 
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public License
* as published by the Free Software Foundation; either version 2
* of the License, or (at your option) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
* 
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "md5.h"
#include "dgp_dec.h"

static void md5_conv(unsigned char* dest,const md5_byte_t src[16])
{
  char a[3];
  int n,i;
  
  for(n=0,i=0;n<16;n++)
  {
    sprintf(a,"%x",src[n]);
    if(a[1]){
      dest[i++]=(unsigned)a[0];
      dest[i++]=(unsigned)a[1];
    }else{
      dest[i++]='0';
      dest[i++]=(unsigned)a[0];
    }
  }
}


int dgp_dec(const char *name,const char *f1,const char *f2)
{
  unsigned char fullname[1024],halfname[512],key[1024],fbuf[512];
  size_t flen,key_pos,fullname_len,key_len,n,i,k;
  md5_state_t md5_full,md5_half;
  md5_byte_t full_md5[16],half_md5[16];
  md5_byte_t full_key[32],half_key[32];
  char err_path[1024];
  FILE *in,*out,*mdh,*mdf,*ferr;

  strcpy(fullname,name);
  strncpy(halfname,fullname,strlen(fullname)/2);
  fullname_len=strlen(fullname);
  
  md5_init(&md5_half);
  md5_append(&md5_half,halfname,fullname_len/2);
  md5_finish(&md5_half,half_md5);
  md5_conv(half_key,half_md5);
  
  mdh=fopen("half.md5","wb");
  fwrite(half_key,1,32,mdh);
  fclose(mdh);
  
  md5_init(&md5_full);
  md5_append(&md5_full,fullname,fullname_len);
  md5_finish(&md5_full,full_md5);
  md5_conv(full_key,full_md5);
  
  memcpy(key,full_key,32);
  memcpy(key+32,fullname,fullname_len);  
  
  for(n=0,i=0;n<strlen(fullname)+32;n++)
  {
    key[n]^=half_key[i++];
    if(i>=32)
      i=0;
  }
  
  key[strlen(fullname)+32]=0;
  key_len=strlen(key);
  if(key_len==0){
  /*
    printf("null key: %s\n",name);
    return 0;
  */
    key_len=1;
    key_pos=0;
  }else if(key_len==1)
    key_pos=0;
  else
    key_pos=1;
  
  mdf=fopen("full.md5","wb");
  fwrite(key,1,key_len,mdf);
  fclose(mdf);
  
  in=fopen(f1,"rb");
  if(in==NULL){
    printf("file error: %s\n",f1);
    return 0;
  }
  out=fopen(f2,"wb");
  if(out==NULL){
    printf("file error: %s\n",f2);
    return 0;
  }
  
  while(1)
  {
    flen=fread(&fbuf,1,512,in);
    if(!flen)
      break;
    for(k=0;k<flen;k++)
    {
      fbuf[k]^=key[key_pos++];
      if(key_pos>=key_len)
        key_pos=0;
    }
    fwrite(fbuf,1,flen,out);
  }
  fclose(in);
  fclose(out);
  
  return 1;
}
